package com.danitheskunk.skunkworks.gfx;

public final class Color {
	public final static Color BLACK = new Color(0, 0, 0);
	public final static Color BLUE = new Color(0, 0, 255);
	public final static Color CYAN = new Color(0, 255, 255);
	public final static Color DARK_GRAY = new Color(64, 64, 64);
	public final static Color GRAY = new Color(128, 128, 128);
	public final static Color GREEN = new Color(0, 255, 0);
	public final static Color LIGHT_GRAY = new Color(192, 192, 192);
	public final static Color MAGENTA = new Color(255, 0, 255);
	public final static Color RED = new Color(255, 0, 0);
	public final static Color TRANS_BLACK = new Color(0, 0, 0, 0);
	public final static Color WHITE = new Color(255, 255, 255);
	public final static Color YELLOW = new Color(255, 255, 0);
	private final int r, g, b, a;


	public Color(int r, int g, int b) {
		this.r = r;
		this.g = g;
		this.b = b;
		this.a = 0xff;
	}

	public Color(int r, int g, int b, int a) {
		this.r = r;
		this.g = g;
		this.b = b;
		this.a = a;
	}

	public int getA() {
		return a;
	}

	public int getB() {
		return b;
	}

	public int getG() {
		return g;
	}

	public int getR() {
		return r;
	}

	@Override
	public String toString() {
		return String.format("#%02X%02X%02X%02X", r, g, b, a);
	}
}
